;(function ($) {
    'use strict'
    var Tags = function (elems) {
        elems = elems || '';
        if (!elems) {
            return;
        };

        var self = this;
        elems.each(function (key, elem) {
            if ($(elem).parent('div.form-tags').length) {
                return;
            };
            $(elem).wrap($('<div class="form-inline form-tags"></div>')).hide();
            var input = $('<input type="text" class="input-tags form-control" />').insertAfter($(elem));
            self.bind(input);
        });
    };

    Tags.prototype = {
        set: function (elems, values) {
            var self = $(elems);
            var Tags = this;
            values = values.reverse();
            elems.each(function (key, elem) {
                for (var key in values) {
                   key = values.length - key - 1;
                   var lastTag = $(elem).nextAll('.label').last();
                   var tag = $('<span class="label label-info">' + values[key] + '</span>');
                    //新的tag会被添加到后面
                    if (lastTag.length) {
                        lastTag.after(tag);
                    } else {
                        $(elem).after(tag);
                    }
                    tag.click(click);
                    Tags.value(tag);
                };
            });
        },
        bind: function (elem) {
            var Tags = this;
            elem.keypress(function (event) {
                var self = $(this);
                var keycode = (event.keyCode ? event.keyCode : event.which);
                //enter key
                if (keycode !== 13) {
                    return;
                };
                event.preventDefault();
                var text = $(this).val();
                if (!text) {
                    return;
                };
                var tag = $('<span class="label label-info">' + text + '</span>');
                self.before(tag).val('');
                tag.click(click);
                Tags.value(elem);

            });
        },
        value: function (elem) {
            var hideInput = elem.prevAll('input,textarea');
            var tags = elem.parent().children('span.label');
            var values = [];
            tags.each(function (key, tag) {
                values.push($(tag).text());
            });
            return hideInput.val(values);
        },
        init: function (elems, obj) {
            this.options = $.extend(this.options, obj);
            this.set(elems, obj.values);
        },
        options: {
            allowRepeat: true, //是否可重复 尚未实现
            hasButton: false, //是否要删除按钮 尚未实现
            values: [] //初始值
        }
    };

    var click = function () {
        var tag = $(this);
        var text = tag.text();
        var input = $('<input class="form-control input-tags" type="text" />');
        tag.after(input).hide();

        input.val(text)
        .focus()
        .blur(function () {
            finish(tag, input);
        })
        .keypress(function (event) {
            var keycode = (event.keyCode ? event.keyCode : event.which);
            if (keycode === 13) {
                event.preventDefault();
                finish(tag, input);
            };
        });
    }
    var finish = function (tag, input) {
        var text = input.val();
        var elem = tag.next('input.input-tags');
        var elemLast = tag.nextAll('input.input-tags').last();
        if (text) {
            tag.text(text).show();
        } else {
            tag.remove();
        }
        new Tags().value(elem);
        input.remove();
        elemLast.focus();
    };

    $.fn.tags = function () {
        var tags = new Tags(this);

        if (Object.prototype.toString.call(arguments[0]) === '[object Array]') {
            var values = arguments[0];
            tags.set(this, values);
        } else if (Object.prototype.toString.call(arguments[0]) === '[object Object]') {
            var values = arguments[0];
            tags.init(this, values);
        } else {
            var values = Array.prototype.slice.call(arguments);
            tags.set(this, values);
        }
        return this;
    };

})(jQuery);

$(function () {
    var style = '<style>'+
                    '.form-tags span {'+
                        'display: inline-block;'+
                        'font-size: 14px;'+
                        'margin: 2px;'+
                        'line-height: 26px;'+
                        'font-weight: normal;
                    }'+
                    '.input-tags{'+
                        'width: auto;'+
                        'display: inline-block;'+
                    '}'+
                '</style>'
    $('head').append($(style));
    $('[data-toggle="tags"]').tags();
});